----------------------------------------------------------------------------------------
--Developer Mode
----------------------------------------------------------------------------------------

--GLOBAL.CHEATS_ENABLED = true
--GLOBAL.require( 'debugkeys' )

--[[
	DISCLAIMER:
	I am by no means a Lua programmer
	There is a lot of code in this mod that is probably done the WRONG way...
	If you are experienced with Lua and you want to help me understand it better, feel free to add me on Steam or email me: nossr50@gmail.com
	I started learning Lua while making mods for DS, and I'm still very much a newbie
--]]

----------------------------------------------------------------------------------------
--SOMETHING LIKE A HEADER I GUESS
----------------------------------------------------------------------------------------

local require 		= GLOBAL.require
_G 					= GLOBAL
local setmetatable 	= _G.setmetatable
local getmetatable 	= _G.getmetatable
local tonumber 		= _G.tonumber
require "class"
local Builder 		= require "components/builder"

----------------------------------------------------------------------------------------
--CONFIG VALUES
----------------------------------------------------------------------------------------
local config_CraftingDifficulty 			= GetModConfigData("Crafting_Difficulty")
--local config_SanityPenalty 				= GetModConfigData("Sanity_Penalty")

_G.TUNNELSANITYPENALTY = GetModConfigData("Sanity_Penalty")
----------------------------------------------------------------------------------------
--PREFAB FILES
----------------------------------------------------------------------------------------

PrefabFiles = 
{
	"tunnel",
	"flag",
}

----------------------------------------------------------------------------------------
--ASSETS
----------------------------------------------------------------------------------------
Assets = 
{
	Asset("ATLAS", 			"images/inventoryimages/tunnel.xml"),
	Asset("SOUNDPACKAGE", 	"sound/tunnel.fev"),
    Asset("SOUND", 			"sound/tunnel.fsb"),
	Asset( "IMAGE", 		"minimap/minimap_tunnel.tex" ),
	Asset( "ATLAS", 		"minimap/minimap_tunnel.xml" ),
}

AddMinimapAtlas("minimap/minimap_tunnel.xml")

----------------------------------------------------------------------------------------
--Utility Functions
----------------------------------------------------------------------------------------
_G.DebugMe = function(obj, levels, seen)
	prefix = "[PARENT]"
	
	if not seen then seen = {} end
	
	if not levels then levels = 0 else levels = levels + 1 end
	
	if levels > 0 then prefix = "["..tostring(levels).."]" end
	
	if obj then
		seen[obj] = true
		print("DebugMe: "..type(obj).."["..tostring(obj).."]")
		for k, v in pairs(obj) do
			print(prefix.."KV: "..type(k).."["..tostring(k).."] | "..type(v).."["..tostring(v).."]")
			if type(v) == "table" and not seen[v] then
				seen[v] = true
				_G.DebugMe(obj, levels, seen)
			end
		end
		
		if levels > 0 then levels = levels - 1 end
		print("End of OBJ [", obj, "]")
	else
		print("DebugMe: "..type(obj))
	end
	
	print("DEBUGME FINISH")
end

_G.Truncate = function(num)
  return tonumber(string.format("%." .. 0 .. "f", num))
end

----------------------------------------------------------------------------------------
--Functions that replace other functions
----------------------------------------------------------------------------------------

--We jump into our tunnels similarly (exactly) to wormholes
GLOBAL.ACTIONS.JUMPIN.fn = function(act)
    if act.target.components.teleporter then
	    act.target.components.teleporter:Activate(act.doer)
	    return true
	elseif act.target.components.tunnelteleporter then 
		act.target.components.tunnelteleporter:Activate(act.doer)
		return true
	end
end

function Builder:CanBuildAtPoint(pt, recipe)
	local ground = _G.GetWorld()
    local tile = _G.GROUND.GRASS
    if ground and _G.GROUND.Map then
        tile = _G.GROUND.Map:GetTileAtPoint(pt:Get())
    end
	
	if recipe.name == "tunnel" and (_G.GetWorld():IsCave() or _G.GetWorld():IsRuins()) then
		return false
	end

	if tile == _G.GROUND.IMPASSABLE then
		return false
	else
		local ents = TheSim:FindEntities(pt.x,pt.y,pt.z, 6, nil, {'player', 'fx', 'NOBLOCK'}) -- or we could include a flag to the search?
		for k, v in pairs(ents) do
			if v ~= self.inst and (not v.components.placer) and v.entity:IsVisible() and not (v.components.inventoryitem and v.components.inventoryitem.owner ) then
				local min_rad = recipe.min_spacing or 2+1.2
				--local rad = (v.Physics and v.Physics:GetRadius() or 1) + 1.25
				
				--stupid finalling hack because it's too late to change stuff
				if recipe.name == "treasurechest" and v.prefab == "pond" then
					min_rad = min_rad + 1
				end

				local dsq = _G.distsq(_G.Vector3(v.Transform:GetWorldPosition()), pt)
				if dsq <= min_rad*min_rad then
					return false
				end
			end
		end
	end
	
	return true
end

----------------------------------------------------------------------------------------
--Character dialogue
----------------------------------------------------------------------------------------

GLOBAL.STRINGS.NAMES.TUNNEL = "Tunnel"
GLOBAL.STRINGS.RECIPE_DESC.TUNNEL = "Make a tunnel network"

GLOBAL.STRINGS.CHARACTERS.GENERIC.DESCRIBE.TUNNEL 			= "Two of these make a network"
GLOBAL.STRINGS.CHARACTERS.WAXWELL.DESCRIBE.TUNNEL 			= "Tch"
GLOBAL.STRINGS.CHARACTERS.WENDY.DESCRIBE.TUNNEL 			= "This hole... it was made for me"
GLOBAL.STRINGS.CHARACTERS.WICKERBOTTOM.DESCRIBE.TUNNEL 		= "Rather primitive"
GLOBAL.STRINGS.CHARACTERS.WILLOW.DESCRIBE.TUNNEL 			= "Shall we set it ablaze?"
GLOBAL.STRINGS.CHARACTERS.WOODIE.DESCRIBE.TUNNEL 			= "Mm.. Chewy"
GLOBAL.STRINGS.CHARACTERS.WOLFGANG.DESCRIBE.TUNNEL 			= "Large muscles; tiny hole"
GLOBAL.STRINGS.CHARACTERS.WX78.DESCRIBE.TUNNEL 				= "QUESTIONABLE PATHFINDING"

GLOBAL.STRINGS.CHARACTERS.GENERIC.ANNOUNCE_TUNNEL 			= "I only remember going in"
GLOBAL.STRINGS.CHARACTERS.WX78.ANNOUNCE_TUNNEL 				= "LOGIC CIRCUITS FRIGHTENED"

if GLOBAL.IsDLCEnabled(GLOBAL.REIGN_OF_GIANTS) then 
	GLOBAL.STRINGS.CHARACTERS.WATHGRITHR.DESCRIBE.TUNNEL 	= "I could fit so much blood in that"
	GLOBAL.STRINGS.CHARACTERS.WEBBER.DESCRIBE.TUNNEL 		= "A perfect place for my kind"
end

--[[
inst:ListenForEvent("tunneltravel", function(inst, data)
	inst.components.talker:Say(GetString(inst.prefab, "ANNOUNCE_TUNNEL"))
end)
--]]

----------------------------------------------------------------------------------------
--CONFIG SETUP
----------------------------------------------------------------------------------------
if config_CraftingDifficulty  == "casual" then
	local tunnel = GLOBAL.Recipe("tunnel",
	{
		Ingredient("boards", 4), 
		Ingredient("rocks", 5), 
		Ingredient("rope", 1),
		Ingredient("twigs", 2),
		Ingredient("shovel", 1),
	},  
	GLOBAL.RECIPETABS.TOWN, GLOBAL.TECH.SCIENCE_ONE, "tunnel_placer" )
	tunnel.atlas = "images/inventoryimages/tunnel.xml"
	tunnel.minspacing = 6.4
elseif config_CraftingDifficulty  == "moderate" then
	local tunnel = GLOBAL.Recipe("tunnel",
	{
		Ingredient("boards", 4), 
		Ingredient("rocks", 5),
		Ingredient("rope", 1),
		Ingredient("papyrus", 1),
		Ingredient("goldenshovel", 1),
	},  
	GLOBAL.RECIPETABS.TOWN, GLOBAL.TECH.SCIENCE_ONE, "tunnel_placer" )
	tunnel.atlas = "images/inventoryimages/tunnel.xml"
	tunnel.minspacing = 6.4
elseif config_CraftingDifficulty  == "difficult" then
	local tunnel = GLOBAL.Recipe("tunnel",
	{
		Ingredient("boards", 8), 
		Ingredient("rocks", 10),
		Ingredient("rope", 1),
		Ingredient("papyrus", 2),
		Ingredient("goldenshovel", 1),
	},  
	GLOBAL.RECIPETABS.TOWN, GLOBAL.TECH.SCIENCE_ONE, "tunnel_placer" )
	tunnel.atlas = "images/inventoryimages/tunnel.xml"
	tunnel.minspacing = 6.4
end

----------------------------------------------------------------------------------------
--Tunnel Manager keeps track of which tunnels are orphans and pairs up tunnels
----------------------------------------------------------------------------------------

function ForestPrefabPostInit(inst)
	inst:AddComponent("tunnel_manager")
end

AddPrefabPostInit("forest", ForestPrefabPostInit)

--For some reason the wormhole sound effect is in the player Jump stategraph...
_G.jumpintimeline = {}

function SimPostInit(player)
	--Store this timeline
	local state = player.sg.sg.states["jumpin"]
	_G.jumpintimeline = state.timeline
end

_G.DisableWormholeJumpNoise = function()
	local player = _G.GetPlayer()
	local state = player.sg.sg.states["jumpin"]
	state.timeline = nil
end

_G.EnableWormholeJumpNoise = function()
	local player = _G.GetPlayer()
	local state = player.sg.sg.states["jumpin"]
	state.timeline = _G.jumpintimeline
end

AddSimPostInit(SimPostInit)